// Copyright PingCAP, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/pingcap/tidb-operator/pkg/apis/pingcap/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeTidbClusterAutoScalers implements TidbClusterAutoScalerInterface
type FakeTidbClusterAutoScalers struct {
	Fake *FakePingcapV1alpha1
	ns   string
}

var tidbclusterautoscalersResource = schema.GroupVersionResource{Group: "pingcap.com", Version: "v1alpha1", Resource: "tidbclusterautoscalers"}

var tidbclusterautoscalersKind = schema.GroupVersionKind{Group: "pingcap.com", Version: "v1alpha1", Kind: "TidbClusterAutoScaler"}

// Get takes name of the tidbClusterAutoScaler, and returns the corresponding tidbClusterAutoScaler object, and an error if there is any.
func (c *FakeTidbClusterAutoScalers) Get(name string, options v1.GetOptions) (result *v1alpha1.TidbClusterAutoScaler, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(tidbclusterautoscalersResource, c.ns, name), &v1alpha1.TidbClusterAutoScaler{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbClusterAutoScaler), err
}

// List takes label and field selectors, and returns the list of TidbClusterAutoScalers that match those selectors.
func (c *FakeTidbClusterAutoScalers) List(opts v1.ListOptions) (result *v1alpha1.TidbClusterAutoScalerList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(tidbclusterautoscalersResource, tidbclusterautoscalersKind, c.ns, opts), &v1alpha1.TidbClusterAutoScalerList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.TidbClusterAutoScalerList{ListMeta: obj.(*v1alpha1.TidbClusterAutoScalerList).ListMeta}
	for _, item := range obj.(*v1alpha1.TidbClusterAutoScalerList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested tidbClusterAutoScalers.
func (c *FakeTidbClusterAutoScalers) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(tidbclusterautoscalersResource, c.ns, opts))

}

// Create takes the representation of a tidbClusterAutoScaler and creates it.  Returns the server's representation of the tidbClusterAutoScaler, and an error, if there is any.
func (c *FakeTidbClusterAutoScalers) Create(tidbClusterAutoScaler *v1alpha1.TidbClusterAutoScaler) (result *v1alpha1.TidbClusterAutoScaler, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(tidbclusterautoscalersResource, c.ns, tidbClusterAutoScaler), &v1alpha1.TidbClusterAutoScaler{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbClusterAutoScaler), err
}

// Update takes the representation of a tidbClusterAutoScaler and updates it. Returns the server's representation of the tidbClusterAutoScaler, and an error, if there is any.
func (c *FakeTidbClusterAutoScalers) Update(tidbClusterAutoScaler *v1alpha1.TidbClusterAutoScaler) (result *v1alpha1.TidbClusterAutoScaler, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(tidbclusterautoscalersResource, c.ns, tidbClusterAutoScaler), &v1alpha1.TidbClusterAutoScaler{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbClusterAutoScaler), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeTidbClusterAutoScalers) UpdateStatus(tidbClusterAutoScaler *v1alpha1.TidbClusterAutoScaler) (*v1alpha1.TidbClusterAutoScaler, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(tidbclusterautoscalersResource, "status", c.ns, tidbClusterAutoScaler), &v1alpha1.TidbClusterAutoScaler{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbClusterAutoScaler), err
}

// Delete takes name of the tidbClusterAutoScaler and deletes it. Returns an error if one occurs.
func (c *FakeTidbClusterAutoScalers) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(tidbclusterautoscalersResource, c.ns, name), &v1alpha1.TidbClusterAutoScaler{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeTidbClusterAutoScalers) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(tidbclusterautoscalersResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.TidbClusterAutoScalerList{})
	return err
}

// Patch applies the patch and returns the patched tidbClusterAutoScaler.
func (c *FakeTidbClusterAutoScalers) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.TidbClusterAutoScaler, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(tidbclusterautoscalersResource, c.ns, name, pt, data, subresources...), &v1alpha1.TidbClusterAutoScaler{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbClusterAutoScaler), err
}
