// Copyright PingCAP, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/pingcap/tidb-operator/pkg/apis/pingcap/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeTidbMonitors implements TidbMonitorInterface
type FakeTidbMonitors struct {
	Fake *FakePingcapV1alpha1
	ns   string
}

var tidbmonitorsResource = schema.GroupVersionResource{Group: "pingcap.com", Version: "v1alpha1", Resource: "tidbmonitors"}

var tidbmonitorsKind = schema.GroupVersionKind{Group: "pingcap.com", Version: "v1alpha1", Kind: "TidbMonitor"}

// Get takes name of the tidbMonitor, and returns the corresponding tidbMonitor object, and an error if there is any.
func (c *FakeTidbMonitors) Get(name string, options v1.GetOptions) (result *v1alpha1.TidbMonitor, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(tidbmonitorsResource, c.ns, name), &v1alpha1.TidbMonitor{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbMonitor), err
}

// List takes label and field selectors, and returns the list of TidbMonitors that match those selectors.
func (c *FakeTidbMonitors) List(opts v1.ListOptions) (result *v1alpha1.TidbMonitorList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(tidbmonitorsResource, tidbmonitorsKind, c.ns, opts), &v1alpha1.TidbMonitorList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.TidbMonitorList{ListMeta: obj.(*v1alpha1.TidbMonitorList).ListMeta}
	for _, item := range obj.(*v1alpha1.TidbMonitorList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested tidbMonitors.
func (c *FakeTidbMonitors) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(tidbmonitorsResource, c.ns, opts))

}

// Create takes the representation of a tidbMonitor and creates it.  Returns the server's representation of the tidbMonitor, and an error, if there is any.
func (c *FakeTidbMonitors) Create(tidbMonitor *v1alpha1.TidbMonitor) (result *v1alpha1.TidbMonitor, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(tidbmonitorsResource, c.ns, tidbMonitor), &v1alpha1.TidbMonitor{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbMonitor), err
}

// Update takes the representation of a tidbMonitor and updates it. Returns the server's representation of the tidbMonitor, and an error, if there is any.
func (c *FakeTidbMonitors) Update(tidbMonitor *v1alpha1.TidbMonitor) (result *v1alpha1.TidbMonitor, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(tidbmonitorsResource, c.ns, tidbMonitor), &v1alpha1.TidbMonitor{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbMonitor), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeTidbMonitors) UpdateStatus(tidbMonitor *v1alpha1.TidbMonitor) (*v1alpha1.TidbMonitor, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(tidbmonitorsResource, "status", c.ns, tidbMonitor), &v1alpha1.TidbMonitor{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbMonitor), err
}

// Delete takes name of the tidbMonitor and deletes it. Returns an error if one occurs.
func (c *FakeTidbMonitors) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(tidbmonitorsResource, c.ns, name), &v1alpha1.TidbMonitor{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeTidbMonitors) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(tidbmonitorsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.TidbMonitorList{})
	return err
}

// Patch applies the patch and returns the patched tidbMonitor.
func (c *FakeTidbMonitors) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.TidbMonitor, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(tidbmonitorsResource, c.ns, name, pt, data, subresources...), &v1alpha1.TidbMonitor{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbMonitor), err
}
