// Copyright PingCAP, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	v1alpha1 "github.com/pingcap/tidb-operator/pkg/apis/pingcap/v1alpha1"
	scheme "github.com/pingcap/tidb-operator/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// TidbInitializersGetter has a method to return a TidbInitializerInterface.
// A group's client should implement this interface.
type TidbInitializersGetter interface {
	TidbInitializers(namespace string) TidbInitializerInterface
}

// TidbInitializerInterface has methods to work with TidbInitializer resources.
type TidbInitializerInterface interface {
	Create(*v1alpha1.TidbInitializer) (*v1alpha1.TidbInitializer, error)
	Update(*v1alpha1.TidbInitializer) (*v1alpha1.TidbInitializer, error)
	UpdateStatus(*v1alpha1.TidbInitializer) (*v1alpha1.TidbInitializer, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.TidbInitializer, error)
	List(opts v1.ListOptions) (*v1alpha1.TidbInitializerList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.TidbInitializer, err error)
	TidbInitializerExpansion
}

// tidbInitializers implements TidbInitializerInterface
type tidbInitializers struct {
	client rest.Interface
	ns     string
}

// newTidbInitializers returns a TidbInitializers
func newTidbInitializers(c *PingcapV1alpha1Client, namespace string) *tidbInitializers {
	return &tidbInitializers{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the tidbInitializer, and returns the corresponding tidbInitializer object, and an error if there is any.
func (c *tidbInitializers) Get(name string, options v1.GetOptions) (result *v1alpha1.TidbInitializer, err error) {
	result = &v1alpha1.TidbInitializer{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("tidbinitializers").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of TidbInitializers that match those selectors.
func (c *tidbInitializers) List(opts v1.ListOptions) (result *v1alpha1.TidbInitializerList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.TidbInitializerList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("tidbinitializers").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested tidbInitializers.
func (c *tidbInitializers) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("tidbinitializers").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a tidbInitializer and creates it.  Returns the server's representation of the tidbInitializer, and an error, if there is any.
func (c *tidbInitializers) Create(tidbInitializer *v1alpha1.TidbInitializer) (result *v1alpha1.TidbInitializer, err error) {
	result = &v1alpha1.TidbInitializer{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("tidbinitializers").
		Body(tidbInitializer).
		Do().
		Into(result)
	return
}

// Update takes the representation of a tidbInitializer and updates it. Returns the server's representation of the tidbInitializer, and an error, if there is any.
func (c *tidbInitializers) Update(tidbInitializer *v1alpha1.TidbInitializer) (result *v1alpha1.TidbInitializer, err error) {
	result = &v1alpha1.TidbInitializer{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("tidbinitializers").
		Name(tidbInitializer.Name).
		Body(tidbInitializer).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *tidbInitializers) UpdateStatus(tidbInitializer *v1alpha1.TidbInitializer) (result *v1alpha1.TidbInitializer, err error) {
	result = &v1alpha1.TidbInitializer{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("tidbinitializers").
		Name(tidbInitializer.Name).
		SubResource("status").
		Body(tidbInitializer).
		Do().
		Into(result)
	return
}

// Delete takes name of the tidbInitializer and deletes it. Returns an error if one occurs.
func (c *tidbInitializers) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("tidbinitializers").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *tidbInitializers) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("tidbinitializers").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched tidbInitializer.
func (c *tidbInitializers) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.TidbInitializer, err error) {
	result = &v1alpha1.TidbInitializer{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("tidbinitializers").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
